#pragma once

#include <windows.h>
#include <string>
#include <map>

#include "SemiFullScreenMod.h"


using namespace std;

using namespace System;
using namespace System::Windows::Forms;
using namespace System::Drawing;

map<std::string, POINT> map_resolution;



ref class DisplaySelectionForm : public Form {
	// x
	Label^ lblResolution;
	// 𑜓x̃Xg{bNX
	ListBox^ lboxResolution;

	// IF̐Fpl
	Panel^ pnlBackColor;
	// F_CAO\邽߂̃{^
	Button^ btnSelectBackColor;

	// F_CAO
	System::Windows::Forms::ColorDialog^ colorDialog;
	// SĐݒ̃{^
	Button^ btnAllSetting;
	

public:
	DisplaySelectionForm() {
		this->Height = 280;
		this->Width = 300;
		this->MaximizeBox = false;

		this->FormBorderStyle = ::FormBorderStyle::FixedSingle;
		this->ShowInTaskbar = false;

		SetFormIcon();

		lblResolution = gcnew Label();
		lblResolution->Text = "Q[Ɉȉ̉ʉ𑜓xɐؑ:";
		lblResolution->Left = 10;
		lblResolution->Top = 10;
		lblResolution->Width  = this->ClientSize.Width - 20;
		lblResolution->Height = 15;

		lboxResolution = gcnew ListBox();
		lboxResolution->Left = 10;
		lboxResolution->Top = 30;
		lboxResolution->Height = 147;
		lboxResolution->Width  = 120;
		lboxResolution->Font = gcnew System::Drawing::Font("MS Gothic", 10 );

		pnlBackColor = gcnew Panel();
		pnlBackColor->BackColor = System::Drawing::Color::Black;
		pnlBackColor->Top = 30;
		pnlBackColor->Left = 140;
		pnlBackColor->Width = 130;
		pnlBackColor->Height = 100;
		pnlBackColor->Click += gcnew EventHandler(this, &DisplaySelectionForm::btnSelectBackColor_Click);

		btnSelectBackColor = gcnew Button();
		btnSelectBackColor->Text = "wiFI";
		btnSelectBackColor->Top = pnlBackColor->Bottom + 10;
		btnSelectBackColor->Left = pnlBackColor->Left;
		btnSelectBackColor->Height = 30;
		btnSelectBackColor->Width = pnlBackColor->Width;

		btnSelectBackColor->Click += gcnew EventHandler(this, &DisplaySelectionForm::btnSelectBackColor_Click);

		colorDialog = gcnew System::Windows::Forms::ColorDialog();

		btnAllSetting = gcnew Button();
		btnAllSetting->Text = "ݒۑ";
		btnAllSetting->Height = 30;
		btnAllSetting->Width = 100;
		btnAllSetting->Top = 195;
		btnAllSetting->Left = (this->ClientSize.Width-btnAllSetting->Width)/2;

		btnAllSetting->Click += gcnew EventHandler(this, &DisplaySelectionForm::btnAllSetting_Click);


		this->Controls->Add( lblResolution );
		this->Controls->Add( lboxResolution );
		this->Controls->Add( pnlBackColor );
		this->Controls->Add( btnSelectBackColor );
		this->Controls->Add( btnAllSetting );

		ReadSelfIniFile();

		// p[X̂ŁAobNJ[ݒ
		if (param.BackColorRGB >= 0 ) {
			SetPanelBackColor(param.BackColorRGB);
		} else {
			SetPanelBackColor(0x112244); // KɎn
		}

		SetDisplayResolutions();
	}

	void SetFormIcon() {
		// ̃vWFNg̃AZũ^Cv擾B
		System::Reflection::Assembly^ prj_assebmly = GetType()->Assembly;
		System::Resources::ResourceManager^ r = gcnew System::Resources::ResourceManager(String::Format("{0}.SemiFullScreenMod", prj_assebmly->GetName()->Name), prj_assebmly);

		System::Drawing::Icon^ iconform = (System::Drawing::Icon^)(r->GetObject("icon"));
		this->Icon = iconform;

	}

	void SetDisplayResolutions() {
		static DEVMODE devmode;          // fBXvC[h

		char sz[100];
		for ( int index=0; TRUE; index++ ) {
			// 
			if( !EnumDisplaySettings( NULL, index, &devmode ) ){
				break;
			}
			
			if ( devmode.dmBitsPerPel >= 16 ) {
				wsprintf(sz, " %4d x %4d", devmode.dmPelsWidth, devmode.dmPelsHeight);

				// ŘÂL[AE̍\̂lƂĊi[Bmapĝ́AEnumDisplaySettingsł͓𑜓xoĂ邽߁B
				POINT rs;
				rs.x = devmode.dmPelsWidth;
				rs.y = devmode.dmPelsHeight;
				std::string key = std::string(sz);
				map_resolution[ key ] = rs;
			}

			index++;
		}

		for (map<string, POINT>::iterator it = map_resolution.begin(); it != map_resolution.end(); it++ ) {
			lboxResolution->Items->Add( gcnew String( it->first.c_str() ) );
		}

		// Ɗi[@ɂEEE
		// p[X̂Ɠ̂I
		BOOL isExist = false;
		for (int i = 0; i < lboxResolution->Items->Count; i++ ) {
			String^ key = (String^)lboxResolution->Items[i];
			wsprintf(sz, "%s", key);
			if ( map_resolution[sz].x == param.ScreenW && map_resolution[sz].y == param.ScreenH ) {
				lboxResolution->SelectedIndex = i;
			}
		}

		// Iꂽ݂̂ȂÃ݂fXNgbv𑜓xƓ̂IB
		// (͐΂ɑI΂͂)
		if ( lboxResolution->SelectedIndex < 0 ) {
			for (int i = 0; i < lboxResolution->Items->Count; i++ ) {
				String^ key = (String^)lboxResolution->Items[i];
				wsprintf(sz, "%s", key);
				if ( map_resolution[sz].x == System::Windows::Forms::Screen::PrimaryScreen->Bounds.Width &&
					 map_resolution[sz].y == System::Windows::Forms::Screen::PrimaryScreen->Bounds.Height ) {
					lboxResolution->SelectedIndex = i;
				}
			}
		}
		
	}

	void SetPanelBackColor(__int64 rgb) {
		__int64 argb = rgb = rgb | 0xFF000000; // At@̐𖳏ő
		Color color = Color::FromArgb( (int)argb );
		this->pnlBackColor->BackColor = color;
	}

	void btnSelectBackColor_Click(Object^ o, EventArgs^ e) {
		System::Windows::Forms::DialogResult dr = colorDialog->ShowDialog();
		if (dr == System::Windows::Forms::DialogResult::OK) {
          // colorDialog1.Color.R, colorDialog1.Color.G, colorDialog1.Color.B);
			pnlBackColor->BackColor = colorDialog->Color;
		}
	}

	void btnAllSetting_Click(Object^ o, EventArgs^ e) {

		int iSelectedIndex = lboxResolution->SelectedIndex;
		if ( iSelectedIndex < 0 ) {
			iSelectedIndex = lboxResolution->Items->Count -1; // 肦Ȃ͂A̎́AŌ̗vf̔ԍƂB
		}
		String^ key = (String^)lboxResolution->Items[iSelectedIndex];
		char sz[100];
		wsprintf(sz, "%s", key);
		int w = map_resolution[sz].x;
		int h = map_resolution[sz].y;


		// g(dll)̃tpX
		String^ selfFullPath = System::Reflection::Assembly::GetExecutingAssembly()->Location;
		// tpXt@C(gqO)
		String^ strBaseName = System::IO::Path::GetFileNameWithoutExtension(selfFullPath);
		String^ strIniName = strBaseName + ".ini"; // ini̖O


		System::Text::Encoding^ sjisEnc = System::Text::Encoding::GetEncoding("Shift_JIS"); // VċL̐ݒf[^́AVċL{̂ƕR[h킹ĂāAScp932B

		System::IO::StreamWriter^ writer = gcnew System::IO::StreamWriter(strIniName, false, sjisEnc);

		writer->WriteLine("-- vCɃfXNgbv́uv𑜓xȉɎ؊");

		String^ line = String::Format( "cmd[\"environment_semi_fullscreen_w\"]={0}\n", w );
		writer->WriteLine(line);

		writer->WriteLine("-- vCɃfXNgbv́ucv𑜓xȉɎ؊");
		line = String::Format( "cmd[\"environment_semi_fullscreen_h\"]={0}\n", h );
		writer->WriteLine(line);

		writer->WriteLine("-- Q[ɃfXNgbvŜȉRGB(0x000000=A0xffffff=A0xFF0000=)F̃t[ŕB");
		line = String::Format( "cmd[\"environment_semi_fullscreen_back_color\"]=0x{0:X2}{1:X2}{2:X2}", pnlBackColor->BackColor.R, pnlBackColor->BackColor.G, pnlBackColor->BackColor.B );
		writer->WriteLine(line);

		writer->Close();

	}



};